
import sys
import signal
import re
import fnmatch
import time
import os
import exceptions
import traceback

import guyumpackage

from guyumpackage import computesize

import yum
import callback

import rpm
import traceback
import yumif
from gyfunctions import *

version = "0.0.1"

class GuyumInstall(yumif.GuyumYum):
    def __init__(self, pkgops = [], sackops = [], options = None, logcb=None):
        yumif.GuyumYum.__init__(self, logcb=logcb)
        self.downloadpkgs = []


    #
    # returns total installation size
    def gettotalamount(self):
        return computesize(self.totalamount)
        
    #
    # resolve dependencies
    def resolvedependencies(self, pkg, progressbar, factor):  
        self.startYum(pkg.repoid, progressbar, -1)
        
        if yum.__version__>='3.0':
            try:
                self.doTsSetup()
            except Exception, e:
                traceback.print_exc(file=sys.stderr)
                raise e

        if yum.__version__<'2.6':
            self.tsInfo.addInstall(pkg)                    
        else:
            self.install(po=pkg)

        try:
            (rescode, restring)=self.resolveDeps()
        except:
            traceback.print_exc(file=sys.stderr)
            raise e
        
        try:
            for txmbr in self.tsInfo.getMembers():

                if txmbr.ts_state in ['i', 'u']:
                    newpkg = guyumpackage.guyumpackage()
                    newpkg.remotepackage(txmbr.po, txmbr.ts_state)
                    self.downloadpkgs.append(newpkg)
                    self.totalamount += (int)(newpkg.pkgsize)
        except:
            traceback.print_exc(file=sys.stderr)    
	
        return self.downloadpkgs
    
        
    #
    # Returns package for installation     
    def getnamedpackage(self, packageid):

        for pkg in self.downloadpkgs:
            if pkg.packageid == packageid:
                return pkg    
        return None        
        
        
    #
    # Install package
    def installpackage(self):
        downloadpkgs = []       
        pbarfactor = 1
        try:

            for txmbr in self.tsInfo.getMembers():

                if txmbr.ts_state in ['i', 'u']:        
                    downloadpkgs.append(txmbr.po)
            msg="Downloading packages"
            self.logcb(pbar1fract=0.1, pbar1text=msg, pbar1factor=pbarfactor, msg=msg)
            self.downloadPkgs(downloadpkgs)       
            msg = "Initializing transaction"
            self.logcb(pbar1fract=0.4, pbar1text=msg, pbar1factor=pbarfactor,  msg=msg) 

        except Exception, e:
            traceback.print_exc(file=sys.stderr)
            raise e
                
        # new callback
        try:
            newcallback = callback.RPMInstallCallback(output=1, instlogcb=self.logcb)
            newcallback.tsInfo = self.tsInfo

            # from depsolve
            self.initActionTs()
            msg = "Populating transaction"
            self.logcb(pbar1fract=0.1, msg=msg, pbar1factor=pbarfactor,  pbar1text=msg )             
            self.populateTs(keepold=0)
            msg = "Checking transaction"            
            self.logcb(pbar1fract=0.1, msg=msg, pbar1factor=pbarfactor,  pbar1text=msg )                         
            self.ts.check()
            self.ts.order()            
            msg = "Running transaction"            
            self.logcb(pbar1fract=0.1, msg=msg, pbar1factor=pbarfactor, pbar1text=msg )                         
            self.runTransaction(cb=newcallback)
            msg = "Cleaning up transaction"            
            self.logcb(pbar1fract=0.1, msg=msg, pbar1factor=pbarfactor, pbar1text=msg )                         
            self.cleartransaction()
            msg = "Finish"            
            self.logcb(pbar1fract=0.1, msg=msg, pbar1factor=pbarfactor, pbar1text=msg )                         
        except Exception, e:
            traceback.print_exc(file=sys.stderr)
            raise e
    
        
    def cleartransaction(self):
        for txmbr in self.tsInfo:
            self.tsInfo.remove(txmbr.po.pkgtup)
        self.totalamount = 0
        
