import sys
import signal
import re
import fnmatch
import time
import os
import exceptions
import string

import yum

from yum.logger import Logger

try:
    import pygtk
    #tell pyGTK, if possible, that we want GTKv2
    pygtk.require("2.0")
except:
    #Some distributions come with GTK2, but not pyGTK
    pass

try:
    import gtk
    import gobject
except:
    print "An error occured"
    sys.exit(1)


from gyfunctions import *
from gyprogbar import *

class GuyumLogger(yum.logger.Logger):
    def __init__(self, threshold = 0,
                        file_object = sys.stderr,
                        prefix = '',
                        prefix_depth = 5,
                        preprefix = '',
                        postprefix = '',
                        default = 1,
                        logcb = None):

        yum.logger.Logger.__init__(self, threshold, file_object, prefix, prefix_depth, preprefix, postprefix, default)
        self.logcb = None
        if logcb is not None:
            self.logcb = logcb
        
    def log(self, priority, message=None):
        p, m = (priority, message)
        if type(m)==type(''):
            mlist = string.split(m, '\n')
            if mlist[-1] == '':
                del mlist[-1]
        elif type(m) == type([]):
            mlist = map(string.rstrip.m)
        else:
            mlist = [str(m)]
        prefix = self.gen_prefix(p)
        for line in mlist:
            if self.logcb is not None:
                self.logcb(msg=line+"\n")
                        
    # make the objects callable
    __call__ = log            
            
    def write(self, priority, message=None):
        print message


