
import sys
import signal
import re
import fnmatch
import time
import os
import exceptions
import string

import yum
import logging

from gyfunctions import *
from gyprogbar import *


class GuyumLogger:
    def __init__(self, threshold = 0,
                        file_object = sys.stderr,
                        prefix = '',
                        prefix_depth = 5,
                        preprefix = '',
                        postprefix = '',
                        default = 1,
                        logcb = None):
        self.logcb = logcb

    def log(self, priority, message=None):
        p, m = (priority, message)
        if type(m)==type(''):
            mlist = string.split(m, '\n')
            if mlist[-1] == '':
                del mlist[-1]
        elif type(m) == type([]):
            mlist = map(string.rstrip.m)
        else:
            mlist = [str(m)]
        for line in mlist:
            self.logcb(msg=line+"\n")

    __call__ = log 
