import sys

try:
    import pygtk
    #tell pyGTK, if possible, that we want GTKv2
    pygtk.require("2.0")
except:
    #Some distributions come with GTK2, but not pyGTK
    pass

try:
    import gtk
    import gtk.glade
    import gobject
except:
    print "An error occured"
    sys.exit(1)

import gnome.ui
from misc import GuyumConst
import guyumquery
from gyfunctions import *

class YumconfDialogTree:
    _YUMPROP_KEY = 0
    _YUMPROP_VALUE = 1
    
    main = ['diskspacecheck', 'exactarchlist', 'installroot', 'reposdir', 'showdupesfromrepos', 'tsflags', 'yumversion' ]
    cache = ['cache', 'cachedir']
    logging = ['debuglevel', 'errorlevel', 'logfile', 'syslog_facility', 'syslog_ident']    
    groups = ['enablegroups', 'overwrite_groups']
    plugins = ['plugins', 'pluginpath', 'pluginconfpath']
    packages = ['distroverpkg', 'exactarch', 'exclude', 'installonlypkgs', 'kernelpkgnames', 'obsoletes', 'recent']
    connection = ['bandwidth', 'failovermethod', 'keepalive', 'proxy', 'proxy_password', 'proxy_username', 'retries', 'throttle', 'timeout', 'tolerant' ]
    
    
    yumprops = { 'Main':main, 'Cache':cache, 'Logging':logging, 'Groups':groups, 
                'Plugins':plugins, 'Packages':packages, 'Connection':connection }
    
    '''
    # constructor 
    ''' 
    def __init__(self):
        self.model = None
        self.treeview = None


    '''
    # add columns to treeview 
    ''' 
    def add_columns(self, treeview):
        if self.treeview == None:
            self.treeview = treeview
            
            # property column
            renderer = gtk.CellRendererText()
            column = gtk.TreeViewColumn( '', renderer, text=self._YUMPROP_KEY )
            column.set_clickable(True)
            column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
            column.connect("clicked", treeviewSortIDSet, (treeview, self._YUMPROP_KEY))
            self.treeview.append_column(column)

            # property column            
            rend_value = gtk.CellRendererText()
            column = gtk.TreeViewColumn( '', rend_value, text=self._YUMPROP_VALUE )
            column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
            self.treeview.append_column(column)
        
        
    '''
    #
    # add data to treemodel
    '''
    def add_data(self, yumconf):
        if self.model!=None:
            self.model = None
        self.model = gtk.TreeStore( gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )

        mainiter = None
        for prop in self.yumprops:
            mainiter = self.model.append(None)
            self.model.set(mainiter,
                            0, prop,
                            1, '')
            
            subiter = None
            for subprop in self.yumprops[prop]:
                subiter = self.model.append(mainiter)
                markup = ''
                if hasattr(yumconf, subprop):
                    yumprop = getattr(yumconf, subprop)

                    if hasattr(yumprop, 'append'):
                        yumprop = ",".join(yumprop)
                        markup = "%s" % yumprop
                    else:
                        markup = yumprop

                self.model.set(subiter,
                               self._YUMPROP_KEY, subprop,                           
                               self._YUMPROP_VALUE, markup)
                               
        #sortmodel = gtk.TreeModelSort(self.model)
        self.treeview.set_model(self.model)
        #sortmodel.set_sort_column_id(self._YUMPROP_KEY, gtk.SORT_ASCENDING)            


